// Copyright (c) .NET Foundation. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

// This file is used by Code Analysis to maintain SuppressMessage
// attributes that are applied to this project.
// Project-level suppressions either have no target or are given
// a specific target and scoped to a namespace, type, member, etc.

using System.Diagnostics.CodeAnalysis;

[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void MSBuildLogger.Log(ILogMessage message)', validate parameter 'message' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildLogger.Log(NuGet.Common.ILogMessage)")]
[assembly: SuppressMessage("Build", "CA1822:Member LogError does not access instance data and can be marked as static (Shared in VisualBasic)", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildLogger.LogError(NuGet.Common.INuGetLogMessage,NuGet.Build.MSBuildLogger.LogErrorWithDetails,NuGet.Build.MSBuildLogger.LogErrorAsString)")]
[assembly: SuppressMessage("Build", "CA1822:Member LogMessage does not access instance data and can be marked as static (Shared in VisualBasic)", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildLogger.LogMessage(NuGet.Common.INuGetLogMessage,Microsoft.Build.Framework.MessageImportance,NuGet.Build.MSBuildLogger.LogMessageWithDetails,NuGet.Build.MSBuildLogger.LogMessageAsString)")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void BuildTasksUtility.AddAllProjectsForRestore(DependencyGraphSpec spec)', validate parameter 'spec' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.BuildTasksUtility.AddAllProjectsForRestore(NuGet.ProjectModel.DependencyGraphSpec)")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void BuildTasksUtility.AddPropertyIfExists(IDictionary<string, string> properties, string key, string value)', validate parameter 'properties' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.BuildTasksUtility.AddPropertyIfExists(System.Collections.Generic.IDictionary{System.String,System.String},System.String,System.String)")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void BuildTasksUtility.AddPropertyIfExists(IDictionary<string, string> properties, string key, string[] value)', validate parameter 'properties' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.BuildTasksUtility.AddPropertyIfExists(System.Collections.Generic.IDictionary{System.String,System.String},System.String,System.String[])")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'void BuildTasksUtility.CopyPropertyIfExists(ITaskItem item, IDictionary<string, string> properties, string key, string toKey)', validate parameter 'properties' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.BuildTasksUtility.CopyPropertyIfExists(Microsoft.Build.Framework.ITaskItem,System.Collections.Generic.IDictionary{System.String,System.String},System.String,System.String)")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'bool BuildTasksUtility.DoesProjectSupportRestore(PackageSpec packageSpec)', validate parameter 'packageSpec' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.BuildTasksUtility.DoesProjectSupportRestore(NuGet.ProjectModel.PackageSpec)~System.Boolean")]
[assembly: SuppressMessage("Build", "CA2225:Provide a method named 'ToConsoleOutLogMessage' or 'FromBuildErrorEventArgs' as an alternate for operator op_Implicit.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.ConsoleOutLogItem.op_Implicit(Microsoft.Build.Framework.BuildErrorEventArgs)~NuGet.Build.Tasks.ConsoleOutLogItem")]
[assembly: SuppressMessage("Build", "CA2225:Provide a method named 'ToConsoleOutLogMessage' or 'FromBuildMessageEventArgs' as an alternate for operator op_Implicit.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.ConsoleOutLogItem.op_Implicit(Microsoft.Build.Framework.BuildMessageEventArgs)~NuGet.Build.Tasks.ConsoleOutLogItem")]
[assembly: SuppressMessage("Build", "CA2225:Provide a method named 'ToConsoleOutLogMessage' or 'FromBuildWarningEventArgs' as an alternate for operator op_Implicit.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.ConsoleOutLogItem.op_Implicit(Microsoft.Build.Framework.BuildWarningEventArgs)~NuGet.Build.Tasks.ConsoleOutLogItem")]
[assembly: SuppressMessage("Build", "CA1031:Modify 'Execute' to catch a more specific allowed exception type, or rethrow the exception.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.GetRestoreSettingsTask.Execute~System.Boolean")]
[assembly: SuppressMessage("Build", "CA1062:In externally visible method 'ISettings RestoreSettingsUtils.ReadSettings(string solutionDirectory, string restoreDirectory, string restoreConfigFile, Lazy<IMachineWideSettings> machineWideSettings, SettingsLoadingContext settingsLoadContext)', validate parameter 'machineWideSettings' is non-null before using it. If appropriate, throw an ArgumentNullException when the argument is null or add a Code Contract precondition asserting non-null argument.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.RestoreSettingsUtils.ReadSettings(System.String,System.String,System.String,System.Lazy{NuGet.Configuration.IMachineWideSettings},NuGet.Configuration.SettingsLoadingContext)~NuGet.Configuration.ISettings")]
[assembly: SuppressMessage("Build", "CA1031:Modify 'Execute' to catch a more specific allowed exception type, or rethrow the exception.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.RestoreTask.Execute~System.Boolean")]
[assembly: SuppressMessage("Build", "CA1303:Method 'bool RestoreTask.Execute()' passes a literal string as parameter 'value' of a call to 'void Console.WriteLine(string value)'. Retrieve the following string(s) from a resource table instead: \"Waiting for debugger to attach.\".", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.RestoreTask.Execute~System.Boolean")]
[assembly: SuppressMessage("Build", "CA1031:Modify 'Process' to catch a more specific allowed exception type, or rethrow the exception.", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.TaskLoggingQueue.Process(System.String)")]
[assembly: SuppressMessage("Build", "CA1303:Method 'bool WriteRestoreGraphTask.Execute()' passes a literal string as parameter 'message' of a call to 'void TaskLoggingHelper.LogWarning(string message, params object[] messageArgs)'. Retrieve the following string(s) from a resource table instead: \"Unable to find a project to restore!\".", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.WriteRestoreGraphTask.Execute~System.Boolean")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetCentralPackageVersionsTask.CentralPackageVersions")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetCentralPackageVersionsTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetReferenceNearestTargetFrameworkTask.AnnotatedProjectReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetReferenceNearestTargetFrameworkTask.AssignedProjects")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetReferenceNearestTargetFrameworkTask.FallbackTargetFrameworks")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreDotnetCliToolsTask.DotnetCliToolReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreDotnetCliToolsTask.RestoreConfigFilePaths")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreDotnetCliToolsTask.RestoreFallbackFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreDotnetCliToolsTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreDotnetCliToolsTask.RestoreSources")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreFrameworkReferencesTask.FrameworkReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreFrameworkReferencesTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreNuGetAuditSuppressionsTask.NuGetAuditSuppressions")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreNuGetAuditSuppressionsTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestorePackageDownloadsTask.PackageDownloads")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestorePackageDownloadsTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestorePackageReferencesTask.PackageReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestorePackageReferencesTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreProjectReferencesTask.ProjectReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreProjectReferencesTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.OutputConfigFilePaths")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.OutputFallbackFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.OutputSources")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.RestoreFallbackFolders")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.RestoreFallbackFoldersOverride")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.RestoreSettingsPerFramework")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.RestoreSources")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSettingsTask.RestoreSourcesOverride")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSolutionProjectsTask.OutputProjectReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.GetRestoreSolutionProjectsTask.ProjectReferences")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.NuGetMessageTask.Args")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.RestoreTask.RestoreGraphItems")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.WarnForInvalidProjectsTask.AllProjects")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.WarnForInvalidProjectsTask.ValidProjects")]
[assembly: SuppressMessage("Build", "CA1819:Properties should not return arrays", Justification = "<Pending>", Scope = "member", Target = "~P:NuGet.Build.Tasks.WriteRestoreGraphTask.RestoreGraphItems")]
[assembly: SuppressMessage("Performance", "CA1819:Properties should not return arrays", Justification = "MSBuild tasks expect arrays.", Scope = "member", Target = "~P:NuGet.Build.Tasks.CheckForDuplicateNuGetItemsTask.Items")]
[assembly: SuppressMessage("Performance", "CA1819:Properties should not return arrays", Justification = "MSBuild tasks expect arrays.", Scope = "member", Target = "~P:NuGet.Build.Tasks.CheckForDuplicateNuGetItemsTask.DeduplicatedItems")]
[assembly: SuppressMessage("Performance", "CA1819:Properties should not return arrays", Justification = "MSBuild tasks expect arrays.", Scope = "member", Target = "~P:NuGet.Build.Tasks.RestoreTask.EmbedInBinlog")]
[assembly: SuppressMessage("Performance", "CA1819:Properties should not return arrays", Justification = "MSBuild tasks expect arrays.", Scope = "member", Target = "~P:NuGet.Build.Tasks.StaticGraphRestoreTaskBase.EmbedInBinlog")]
[assembly: SuppressMessage("Usage", "CA2208:Instantiate argument exceptions correctly", Justification = "Argument comes from another method.", Scope = "member", Target = "~M:NuGet.Build.Tasks.TaskLoggingQueue.ConsoleOutLogItemConverter.Create(System.Type)~NuGet.Build.Tasks.ConsoleOutLogItem")]
[assembly: SuppressMessage("Design", "CA1031:Do not catch general exception types", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.GetGlobalPropertyValueTask.GetGlobalProperties(NuGet.Common.ILogger)~System.Collections.Generic.IReadOnlyDictionary{System.String,System.String}")]
[assembly: SuppressMessage("Design", "CA1031:Do not catch general exception types", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.StaticGraphRestoreTaskBase.Execute~System.Boolean")]
[assembly: SuppressMessage("Design", "CA1031:Do not catch general exception types", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.StaticGraphRestoreTaskBase.GetGlobalProperties~System.Collections.Generic.Dictionary{System.String,System.String}")]

/* Unmerged change from project 'NuGet.Build.Tasks (net8.0)'
Added:
[assembly: SuppressMessage("Performance", "CA1822:Mark members as static", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.CheckForDuplicateNuGetItemsTask.EvaluateWarningProperties(System.String,System.String,System.String,System.String)~NuGet.ProjectModel.WarningProperties")]
*/
[assembly: SuppressMessage("Performance", "CA1822:Mark members as static", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.CheckForDuplicateNuGetItemsTask.EvaluateWarningProperties(System.String,System.String,System.String,System.String)~NuGet.ProjectModel.WarningProperties")]
[assembly: SuppressMessage("Performance", "CA1822:Mark members as static", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.Tasks.StaticGraphRestoreTaskBase.GetProcessFileName(System.String)~System.String")]
[assembly: SuppressMessage("Performance", "CA1825:Avoid zero-length array allocations", Justification = "<Pending>", Scope = "member", Target = "~M:NuGet.Build.MSBuildUtility.WrapMSBuildItem(System.Collections.Generic.IEnumerable{Microsoft.Build.Framework.ITaskItem})~NuGet.Commands.IMSBuildItem[]")]
